Unit AER18D_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AER18D(NM :Integer; N :Integer; var A :Array of Extended;
                var D :Array of Extended; var E :Array of Extended;
                var E2 :Array of Extended);

implementation

procedure AER18D(NM :Integer; N :Integer; var A :Array of Extended;
                var D :Array of Extended; var E :Array of Extended;
                var E2 :Array of Extended);
var
I,J,K,L,II,JP1 :Integer;
F,G,H,SCALE :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14;
begin
for I:=1 to N do
 begin
_1:
  D[I-1] := A[(I-1)+(I-1)*NM];
 end;
{  ********** }
for II:=1 to N do
 begin
  I := N+1-II;
  L := I-1;
  H := 0.0e0;
  SCALE := 0.0e0;
  if ( L < 1 ) 
   then goto _3;
{  ********** }
  for K:=1 to L do
   begin
_2:
    SCALE := SCALE+Abs(A[(I-1)+(K-1)*NM]);
   end;
  if ( SCALE <> 0.0e0 ) 
   then goto _4;
_3:
  E[I-1] := 0.0e0;
  E2[I-1] := 0.0e0;
  goto _13;
_4:
  for K:=1 to L do
   begin
    A[(I-1)+(K-1)*NM] := A[(I-1)+(K-1)*NM]/SCALE;
    H := H+A[(I-1)+(K-1)*NM]*A[(I-1)+(K-1)*NM];
_5:
   end;
  E2[I-1] := SCALE*SCALE*H;
  F := A[(I-1)+(L-1)*NM];
  G := -Sign(Sqrt(H),F);
  E[I-1] := SCALE*G;
  H := H-F*G;
  A[(I-1)+(L-1)*NM] := F-G;
  if ( L = 1 ) 
   then goto _11;
  F := 0.0e0;
  for J:=1 to L do
   begin
    G := 0.0e0;
{  ********** }
    for K:=1 to J do
     begin
_6:
      G := G+A[(J-1)+(K-1)*NM]*A[(I-1)+(K-1)*NM];
     end;
    JP1 := J+1;
    if ( L < JP1 ) 
     then goto _8;
    for K:=JP1 to L do
     begin
_7:
      G := G+A[(K-1)+(J-1)*NM]*A[(I-1)+(K-1)*NM];
     end;
{  ********** }
_8:
    E[J-1] := G/H;
    F := F+E[J-1]*A[(I-1)+(J-1)*NM];
_9:
   end;
  H := F/(H+H);
{  ********** }
  for J:=1 to L do
   begin
    F := A[(I-1)+(J-1)*NM];
    G := E[J-1]-H*F;
    E[J-1] := G;
    for K:=1 to J do
     begin
      A[(J-1)+(K-1)*NM] := A[(J-1)+(K-1)*NM]-F*E[K-1]-G*A[(I-1)+(K-1)*NM];
_10:
     end;
   end;
_11:
  for K:=1 to L do
   begin
_12:
    A[(I-1)+(K-1)*NM] := SCALE*A[(I-1)+(K-1)*NM];
   end;
_13:
  H := D[I-1];
  D[I-1] := A[(I-1)+(I-1)*NM];
  A[(I-1)+(I-1)*NM] := H;
_14:
 end;
end;

end.
